# Основы программирования 2022

В репозитории находится код с практик, проводимых
для курса *Основы программирования*.

Код желательно запускать из терминала.
Например, в linux можно:

```sh
$ cd programming-basics
$ pwd
/home/apr/edu/22/repos/programming-basics
$ ls
01 02 ...
$ cd 01
$ cat README.md
```

## Как решать задания

- внимательно прочитайте задание;
- если в задании упоминается команда, например, `find`,
попробуйте поискать/попинать `man`, `info`, `help`; но не торопитесь усердствовать
с их чтением: за раз всё в голове, скорее всего, не осядет, поэтому интересные
вещи лучше отложить и читать постепенно и последовательно (а ещё хорошо спать
и регулярно питаться, ага);
- вместо усердного чтения лучше попробуйте прочитать краткое описание и
предположить _что_ эта программа могла бы делать
(обычно секции **NAME**, **SYNOPSIS** в man-страницах или листать оглавление info-страниц
и искать что-нибудь со словами `introduction`, `example`, `real use` и пр.);
unix (и, как следствие, linux) так устроен, что _обычно_ одна программа выполняет
одну функцию, но делает это по возможности хорошо; 
- после этого попытайтесь накидать _хоть какое-нибудь рабочее решение_;
- как только у Вас получилось написать первое рабочее решение, вспомните, что Вы
прекрасны;
- попробуйте (возможно, кстати, не сразу, а на следующий день или через
несколько дней) упростить или улучшить Ваше решение; обычно это идёт на пользу
и Вам и Вашим скриптам;
- с каждым таким улучшением, опять же, постарайтесь себя похвалить и
порадоваться, что у Вас получился, _возможно_, более читаемый и красивый
скрипт;

## Материалы

**(!)** [wiki-страница курса]

**(!)** [список литературы на CSCWiki]

**(!)** web-ресурсы:

* посмотреть как исполняется код в ваших любимых языках программирования:
[pythontutor];
* почитать объяснение shell-команды: [explain shell];




[wiki-страница курса]: https://cs-sh.xyz/d/ompwiki
[pythontutor]: https://pythontutor.com
[explain shell]: https://explainshell.com/explain?cmd=find+.+-name+%27*.py%27+-printf+%22x%22+%7C+grep+-oc+x
[список литературы на CSCWiki]: https://wiki.compscicenter.ru/index.php/%D0%9E%D0%9C%D0%9F_1MIT_%D0%BE%D1%81%D0%B5%D0%BD%D1%8C_1_2022#.D0.9B.D0.B8.D1.82.D0.B5.D1.80.D0.B0.D1.82.D1.83.D1.80.D0.B0
